洛谷P3435 [POI2006] OKR-Periods of Words 题解

洛谷P3435 [POI2006] OKR-Periods of Words 题解

题目链接:P3435 [POI2006] OKR-Periods of Words

题意

对于一个仅含小写字母的字符串 a a a p p p a a a 的前缀且 p ≠ a p\ne a p=a,那么我们称 p p p a a a 的 proper 前缀。

规定字符串 Q Q Q(可以是空串)表示 a a a 的周期,当且仅当 Q Q Q a a a 的 proper 前缀且 a a a Q + Q Q+Q Q+Q 的前缀。

例如 ababab 的一个周期,因为 ababab 的 proper 前缀,且 ababab+ab 的前缀。

求给定字符串所有前缀的最大周期长度之和。

1 ≤ ∣ a ∣ ≤ 1 0 6 1\le |a| \le 10^6 1a106

考虑如何最大化周期 Q Q Q

对于某个前缀,例如 s = a a b a a a a b s = \tt{aabaaaab} s=aabaaaab

不难发现它的最长周期就是 a a b a a \tt{aabaa} aabaa

仔细观察 a a b a a a a b \tt{\color{red}{aab}\color{blue}{aa}\color{red}{aab}} aabaaaab

其实这个 Q = a a b a a Q = \tt{\color{red}{aab}\color{blue}{aa}} Q=aabaa

就是 s s s最短非空border a a b \tt{\color{red}{aab}} aab 加上中间那一段东西

这样对于每个 i i i ,我们只要找到它的最短border就好了

这个东西可以通过跳fail数组实现

但是如果每次都暴力跳,显然会有很多重复步骤

这个跳的过程,是不是很熟悉?并查集也是这么跳的对吧!

并查集可以路径压缩,这里fail数组我们也可以路径压缩。

时间复杂度 O ( n ) O(n) O(n)

代码:

#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
using namespace std;
#define int long long
#define INF 0x3f3f3f3f3f3f3f3f
#define N (int)(1e6+15)

char s[N];
int n,res,fail[N];
signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    // freopen("check.in","r",stdin);
    // freopen("check.out","w",stdout);
    cin >> n >> (s+1);
    for(int i=2,j=0; i<=n; i++)
    {
        while(j&&s[i]!=s[j+1])j=fail[j];
        if(s[i]==s[j+1])++j;
        fail[i]=j;
    }
    for(int i=1,j; i<=n; i++)
    {
        j=i;
        while(fail[j]) j=fail[j];
        if(fail[i]!=0) fail[i]=j;
        res+=(i-j);
    }
    cout << res << '\n';
    return 0;
}

转载请说明出处

你可能感兴趣的:(OI,算法,数据结构)